#include <winsock2.h>
#include <ws2tcpip.h>
#include <stdlib.h>
#include <stdio.h>
#include <iostream>

int main(int argc, const char* argv[])
{
	if(argc < 3)
	{
		std::cout << "<konnekt:info>Brak adresu i/lub portu.</konnekt:info>";
		return 0;
	}
	int tries;
	if(argc == 3)
	{
		tries = 1;
	}
	else
	{
		tries = atoi(argv[3]);
	}

	WSADATA wsaData;
	SOCKET ConnectSocket = INVALID_SOCKET;
	addrinfo* result = NULL, * ptr = NULL, hints;
	int iResult;

	iResult = WSAStartup(MAKEWORD(2,2), &wsaData);
	if(iResult != 0)
	{
		std::cout << "<konnekt:info>Nie udao si uruchomi WinSocka.</konnekt:info>";
		return 0;
	}

	ZeroMemory(&hints, sizeof(hints));
	hints.ai_family = AF_UNSPEC;
	hints.ai_socktype = SOCK_STREAM;
	hints.ai_protocol = IPPROTO_TCP;

	iResult = getaddrinfo(argv[1], argv[2], &hints, &result);
	if(iResult != 0)
	{
		std::cout << "<konnekt:info>Nie udao si uzyska inforacji o adresie.</konnekt:info>";
		WSACleanup();
		return 0;
	}

	ConnectSocket = socket(result->ai_family, result->ai_socktype, result->ai_protocol);
	if(ConnectSocket == INVALID_SOCKET)
	{
		std::cout << "<konnekt:info>Nie udao si stworzy socketa.</konnekt:info>";
		freeaddrinfo(result);
		WSACleanup();
		return 0;
	}

	for(unsigned i = 0; i != tries; i++)
	{
		iResult = connect(ConnectSocket, result->ai_addr, (int)result->ai_addrlen);
		if(iResult != SOCKET_ERROR)
		{
			std::cout << "<konnekt:info>Poczenie - OK.</konnekt:info>";
			closesocket(ConnectSocket);
			WSACleanup();
			return 0;
		}
	}

	std::cout << "<konnekt:info>Nie udao si poczy.</konnekt:info>";
	closesocket(ConnectSocket);
	ConnectSocket = INVALID_SOCKET;
	return 0;
}
